/*
 * Copyright (c) 2004 Massachusetts Institute of Technology
 * Copyright (c) 2004 Eitan Ben Amos
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or (at
 *  your option) any later version.
 *  
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
 *  USA.
 *
 */

/*
 * This file contains code that is required when using non gcc compilers.
 * the gcc-builtin routines should then be supplied by this module.
 */

#include "compiler-dep.h"

FILE_IDENTITY(ident,
	      "$HeadURL: https://bradley.lcs.mit.edu/svn/repos/cilk/current/runtime/gcc-builtin.c $ $LastChangedBy: bradley $ $Rev: 1116 $ $Date: 2003-07-24 00:36:48 -0400 (Thu, 24 Jul 2003) $");

#include <cilk.h>
#include <cilk-internal.h>
#include <stdlib.h>




void __eprintf (const char *format,
		const char *file,
		unsigned   line,
		const char *msg)
{
	printf("__eprintf was called\n");
	abort();
}

